%define zlib_prefix     /usr/local/openresty/zlib
%define zlib_prefix_asan	/usr/local/openresty-asan/zlib

Summary:            The zlib compression library for OpenResty
Name:               openresty-zlib
Version:            1.3
Release:            6%{?dist}
License:            zlib and Boost
URL:                https://openresty.org/
Source0:            https://github.com/madler/zlib/releases/download/v%{version}/zlib-%{version}.tar.xz
Patch3000:          copy-dir.patch

BuildRequires:      libtool
Requires:           zlib

AutoReqProv:        no

%description
The zlib compression library for use by OpenResty ONLY


%package devel

Summary:            Development files for OpenResty's zlib library
Requires:           %{name} = %{version}-%{release}

%description devel
Provides C header and static library for OpenResty's zlib library.

%package asan
Summary:            Clang AddressSanitizer version for the zlib compression library for OpenResty
BuildRequires:      libtool, clang, compiler-rt
AutoReqProv:        no

%description asan
The zlib compression library for use by Openresty ONLY. This is the clang AddressSanitizer build.


%package asan-devel
Summary:            Development files for OpenResty's zlib library
Requires:           openresty-zlib-asan = %{version}-%{release}


%description asan-devel
Provides C header and static library for OpenResty's clang AddressSanitizer version of zlib library.


%prep
%autosetup -p1 -n zlib-%{version}


%build
bash ./copy-dir.sh
./configure --prefix=%{zlib_prefix}
make -j`nproc` CFLAGS='-O3 -fPIC -D_LARGEFILE64_SOURCE=1 -DHAVE_HIDDEN -g3' \
    SFLAGS='-O3 -fPIC -D_LARGEFILE64_SOURCE=1 -DHAVE_HIDDEN -g3' \
    > /dev/stderr

cd asan 
export ASAN_OPTIONS=detect_leaks=0

./configure --prefix=%{zlib_prefix_asan}

make -j`nproc` CC="gcc -fsanitize=address" \
    CFLAGS='-O1 -fno-omit-frame-pointer -fPIC -D_LARGEFILE64_SOURCE=1 -DHAVE_HIDDEN -g3' \
    SFLAGS='-O1 -fno-omit-frame-pointer -fPIC -D_LARGEFILE64_SOURCE=1 -DHAVE_HIDDEN -g3' \
    LDSHARED='gcc -fsanitize=address -shared -Wl,-soname,libz.so.1,--version-script,zlib.map' \
    > /dev/stderr

cd -

%install
make install DESTDIR=%{buildroot}
rm -rf %{buildroot}/%{zlib_prefix}/share
rm -f  %{buildroot}/%{zlib_prefix}/lib/*.la
rm -rf %{buildroot}/%{zlib_prefix}/lib/pkgconfig

cd asan
make install DESTDIR=%{buildroot}
rm -rf %{buildroot}/%{zlib_prefix_asan}/share
rm -f  %{buildroot}/%{zlib_prefix_asan}/lib/*.la
rm -rf %{buildroot}/%{zlib_prefix_asan}/lib/pkgconfig
cd -

%files
%defattr(-,root,root,-)

%dir %{zlib_prefix}
%dir %{zlib_prefix}/lib
%attr(0755,root,root) %{zlib_prefix}/lib/libz.so*


%files devel
%defattr(-,root,root,-)
%{zlib_prefix}/lib/*.a
%{zlib_prefix}/include/zlib.h
%{zlib_prefix}/include/zconf.h

%files asan
%defattr(-,root,root,-)

%attr(0755,root,root) %{zlib_prefix_asan}/lib/libz.so*


%files asan-devel
%defattr(-,root,root,-)
%{zlib_prefix_asan}/lib/*.a
%{zlib_prefix_asan}/include/zlib.h
%{zlib_prefix_asan}/include/zconf.h


%changelog
* Wed May 8 2024 Pengda Dou <doupengda@loongson.cn> - 1.3-6
- Change zlib download link

* Fri Feb 02 2024 kianli <kianli@tencent.com> - 1.3-5
- set AutoReqProv no for asan subpackage

* Wed Jan 31 2024 Feng Weiyao <wynnfeng@tencent.com> - 1.3-4
- set AutoReqProv no

* Mon Dec 25 2023 luffyluo <luffyluo@tencent.com> - 1.3-3
- Rebuilt for llvm 17.0.6

* Fri Dec 8 2023 Feng Weiyao <wynnfeng@tencent.com> - 1.3-2
- initial build for opencloudos

* Wed Sep 13 2023 Yichun Zhang (agentzh) 1.3-1
- upgraded zlib to 1.3.

* Wed Nov 30 2022 Yichun Zhang (agentzh) 1.2.13-1
- upgraded zlib to 1.2.13.

* Thu Mar 31 2022 Yichun Zhang (agentzh) 1.2.12-1
- upgraded zlib to 1.2.12.

* Fri Jul 14 2017 Yichun Zhang 1.2.11-3
- bugfix: we did not enable debuginfo in the shared library files.

* Sat May 20 2017 Yichun Zhang 1.2.11-2
- added debuginfo.

* Sun Mar 19 2017 Yichun Zhang (agentzh) 1.2.11-1
- upgraded zlib to 1.2.11.
